/**
 * <copyright>
 * </copyright>
 *
 * $Id: VoiceItemProviderAdapterFactory.java,v 1.1 2008-04-10 15:47:16 vmahe Exp $
 */
package com.orange_ftgroup.voice.provider;

import com.orange_ftgroup.voice.util.VoiceAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class VoiceItemProviderAdapterFactory extends VoiceAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection supportedTypes = new ArrayList();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VoiceItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);		
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Parameter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParameterItemProvider parameterItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Parameter}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createParameterAdapter() {
		if (parameterItemProvider == null) {
			parameterItemProvider = new ParameterItemProvider(this);
		}

		return parameterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Operation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OperationItemProvider operationItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Operation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createOperationAdapter() {
		if (operationItemProvider == null) {
			operationItemProvider = new OperationItemProvider(this);
		}

		return operationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Constraint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConstraintItemProvider constraintItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Constraint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConstraintAdapter() {
		if (constraintItemProvider == null) {
			constraintItemProvider = new ConstraintItemProvider(this);
		}

		return constraintItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Package} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PackageItemProvider packageItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Package}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createPackageAdapter() {
		if (packageItemProvider == null) {
			packageItemProvider = new PackageItemProvider(this);
		}

		return packageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.DataType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataTypeItemProvider dataTypeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.DataType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDataTypeAdapter() {
		if (dataTypeItemProvider == null) {
			dataTypeItemProvider = new DataTypeItemProvider(this);
		}

		return dataTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Tag} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TagItemProvider tagItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Tag}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createTagAdapter() {
		if (tagItemProvider == null) {
			tagItemProvider = new TagItemProvider(this);
		}

		return tagItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Property} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyItemProvider propertyItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Property}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createPropertyAdapter() {
		if (propertyItemProvider == null) {
			propertyItemProvider = new PropertyItemProvider(this);
		}

		return propertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Class} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClassItemProvider classItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Class}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createClassAdapter() {
		if (classItemProvider == null) {
			classItemProvider = new ClassItemProvider(this);
		}

		return classItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.BinaryExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BinaryExpressionItemProvider binaryExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.BinaryExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createBinaryExpressionAdapter() {
		if (binaryExpressionItemProvider == null) {
			binaryExpressionItemProvider = new BinaryExpressionItemProvider(this);
		}

		return binaryExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.UnaryExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UnaryExpressionItemProvider unaryExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.UnaryExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createUnaryExpressionAdapter() {
		if (unaryExpressionItemProvider == null) {
			unaryExpressionItemProvider = new UnaryExpressionItemProvider(this);
		}

		return unaryExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.CharacterValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CharacterValueItemProvider characterValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.CharacterValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCharacterValueAdapter() {
		if (characterValueItemProvider == null) {
			characterValueItemProvider = new CharacterValueItemProvider(this);
		}

		return characterValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.IntegerValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IntegerValueItemProvider integerValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.IntegerValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createIntegerValueAdapter() {
		if (integerValueItemProvider == null) {
			integerValueItemProvider = new IntegerValueItemProvider(this);
		}

		return integerValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.FloatValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FloatValueItemProvider floatValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.FloatValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createFloatValueAdapter() {
		if (floatValueItemProvider == null) {
			floatValueItemProvider = new FloatValueItemProvider(this);
		}

		return floatValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.BooleanValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BooleanValueItemProvider booleanValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.BooleanValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createBooleanValueAdapter() {
		if (booleanValueItemProvider == null) {
			booleanValueItemProvider = new BooleanValueItemProvider(this);
		}

		return booleanValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.CharstringValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CharstringValueItemProvider charstringValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.CharstringValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCharstringValueAdapter() {
		if (charstringValueItemProvider == null) {
			charstringValueItemProvider = new CharstringValueItemProvider(this);
		}

		return charstringValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Ident} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IdentItemProvider identItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Ident}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createIdentAdapter() {
		if (identItemProvider == null) {
			identItemProvider = new IdentItemProvider(this);
		}

		return identItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ParenthesisExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParenthesisExpressionItemProvider parenthesisExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ParenthesisExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createParenthesisExpressionAdapter() {
		if (parenthesisExpressionItemProvider == null) {
			parenthesisExpressionItemProvider = new ParenthesisExpressionItemProvider(this);
		}

		return parenthesisExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ConditionalExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionalExpressionItemProvider conditionalExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ConditionalExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConditionalExpressionAdapter() {
		if (conditionalExpressionItemProvider == null) {
			conditionalExpressionItemProvider = new ConditionalExpressionItemProvider(this);
		}

		return conditionalExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ListExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ListExpressionItemProvider listExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ListExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createListExpressionAdapter() {
		if (listExpressionItemProvider == null) {
			listExpressionItemProvider = new ListExpressionItemProvider(this);
		}

		return listExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.CallExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallExpressionItemProvider callExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.CallExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCallExpressionAdapter() {
		if (callExpressionItemProvider == null) {
			callExpressionItemProvider = new CallExpressionItemProvider(this);
		}

		return callExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.EnumerationType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumerationTypeItemProvider enumerationTypeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.EnumerationType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createEnumerationTypeAdapter() {
		if (enumerationTypeItemProvider == null) {
			enumerationTypeItemProvider = new EnumerationTypeItemProvider(this);
		}

		return enumerationTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.EnumerationItem} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumerationItemItemProvider enumerationItemItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.EnumerationItem}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createEnumerationItemAdapter() {
		if (enumerationItemItemProvider == null) {
			enumerationItemItemProvider = new EnumerationItemItemProvider(this);
		}

		return enumerationItemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ChoiceType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ChoiceTypeItemProvider choiceTypeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ChoiceType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createChoiceTypeAdapter() {
		if (choiceTypeItemProvider == null) {
			choiceTypeItemProvider = new ChoiceTypeItemProvider(this);
		}

		return choiceTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ListType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ListTypeItemProvider listTypeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ListType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createListTypeAdapter() {
		if (listTypeItemProvider == null) {
			listTypeItemProvider = new ListTypeItemProvider(this);
		}

		return listTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Variable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VariableItemProvider variableItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Variable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createVariableAdapter() {
		if (variableItemProvider == null) {
			variableItemProvider = new VariableItemProvider(this);
		}

		return variableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.InformalExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InformalExpressionItemProvider informalExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.InformalExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createInformalExpressionAdapter() {
		if (informalExpressionItemProvider == null) {
			informalExpressionItemProvider = new InformalExpressionItemProvider(this);
		}

		return informalExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ActionSequence} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActionSequenceItemProvider actionSequenceItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ActionSequence}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createActionSequenceAdapter() {
		if (actionSequenceItemProvider == null) {
			actionSequenceItemProvider = new ActionSequenceItemProvider(this);
		}

		return actionSequenceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.DigitValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DigitValueItemProvider digitValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.DigitValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDigitValueAdapter() {
		if (digitValueItemProvider == null) {
			digitValueItemProvider = new DigitValueItemProvider(this);
		}

		return digitValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.DTMFValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DTMFValueItemProvider dtmfValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.DTMFValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDTMFValueAdapter() {
		if (dtmfValueItemProvider == null) {
			dtmfValueItemProvider = new DTMFValueItemProvider(this);
		}

		return dtmfValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.FeatureExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FeatureExpressionItemProvider featureExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.FeatureExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createFeatureExpressionAdapter() {
		if (featureExpressionItemProvider == null) {
			featureExpressionItemProvider = new FeatureExpressionItemProvider(this);
		}

		return featureExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.PropertyExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyExpressionItemProvider propertyExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.PropertyExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createPropertyExpressionAdapter() {
		if (propertyExpressionItemProvider == null) {
			propertyExpressionItemProvider = new PropertyExpressionItemProvider(this);
		}

		return propertyExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.CollectionRange} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CollectionRangeItemProvider collectionRangeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.CollectionRange}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCollectionRangeAdapter() {
		if (collectionRangeItemProvider == null) {
			collectionRangeItemProvider = new CollectionRangeItemProvider(this);
		}

		return collectionRangeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.CollectionLiteralExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CollectionLiteralExpressionItemProvider collectionLiteralExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.CollectionLiteralExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCollectionLiteralExpressionAdapter() {
		if (collectionLiteralExpressionItemProvider == null) {
			collectionLiteralExpressionItemProvider = new CollectionLiteralExpressionItemProvider(this);
		}

		return collectionLiteralExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.CollectionItem} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CollectionItemItemProvider collectionItemItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.CollectionItem}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCollectionItemAdapter() {
		if (collectionItemItemProvider == null) {
			collectionItemItemProvider = new CollectionItemItemProvider(this);
		}

		return collectionItemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.EnumValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumValueItemProvider enumValueItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.EnumValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createEnumValueAdapter() {
		if (enumValueItemProvider == null) {
			enumValueItemProvider = new EnumValueItemProvider(this);
		}

		return enumValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.StateMachine} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StateMachineItemProvider stateMachineItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.StateMachine}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createStateMachineAdapter() {
		if (stateMachineItemProvider == null) {
			stateMachineItemProvider = new StateMachineItemProvider(this);
		}

		return stateMachineItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.NewExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NewExpressionItemProvider newExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.NewExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createNewExpressionAdapter() {
		if (newExpressionItemProvider == null) {
			newExpressionItemProvider = new NewExpressionItemProvider(this);
		}

		return newExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ValueContainer} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValueContainerItemProvider valueContainerItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ValueContainer}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createValueContainerAdapter() {
		if (valueContainerItemProvider == null) {
			valueContainerItemProvider = new ValueContainerItemProvider(this);
		}

		return valueContainerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Dialog} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DialogItemProvider dialogItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Dialog}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDialogAdapter() {
		if (dialogItemProvider == null) {
			dialogItemProvider = new DialogItemProvider(this);
		}

		return dialogItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.SubDialogState} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SubDialogStateItemProvider subDialogStateItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.SubDialogState}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createSubDialogStateAdapter() {
		if (subDialogStateItemProvider == null) {
			subDialogStateItemProvider = new SubDialogStateItemProvider(this);
		}

		return subDialogStateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Transition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TransitionItemProvider transitionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Transition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createTransitionAdapter() {
		if (transitionItemProvider == null) {
			transitionItemProvider = new TransitionItemProvider(this);
		}

		return transitionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Trigger} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TriggerItemProvider triggerItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Trigger}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createTriggerAdapter() {
		if (triggerItemProvider == null) {
			triggerItemProvider = new TriggerItemProvider(this);
		}

		return triggerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.WaitState} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WaitStateItemProvider waitStateItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.WaitState}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createWaitStateAdapter() {
		if (waitStateItemProvider == null) {
			waitStateItemProvider = new WaitStateItemProvider(this);
		}

		return waitStateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.AnyState} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AnyStateItemProvider anyStateItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.AnyState}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAnyStateAdapter() {
		if (anyStateItemProvider == null) {
			anyStateItemProvider = new AnyStateItemProvider(this);
		}

		return anyStateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ListState} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ListStateItemProvider listStateItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ListState}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createListStateAdapter() {
		if (listStateItemProvider == null) {
			listStateItemProvider = new ListStateItemProvider(this);
		}

		return listStateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.DecisionNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DecisionNodeItemProvider decisionNodeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.DecisionNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDecisionNodeAdapter() {
		if (decisionNodeItemProvider == null) {
			decisionNodeItemProvider = new DecisionNodeItemProvider(this);
		}

		return decisionNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.InitialNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InitialNodeItemProvider initialNodeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.InitialNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createInitialNodeAdapter() {
		if (initialNodeItemProvider == null) {
			initialNodeItemProvider = new InitialNodeItemProvider(this);
		}

		return initialNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.JunctionNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected JunctionNodeItemProvider junctionNodeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.JunctionNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createJunctionNodeAdapter() {
		if (junctionNodeItemProvider == null) {
			junctionNodeItemProvider = new JunctionNodeItemProvider(this);
		}

		return junctionNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.DiversionNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DiversionNodeItemProvider diversionNodeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.DiversionNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDiversionNodeAdapter() {
		if (diversionNodeItemProvider == null) {
			diversionNodeItemProvider = new DiversionNodeItemProvider(this);
		}

		return diversionNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.HistoryState} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HistoryStateItemProvider historyStateItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.HistoryState}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createHistoryStateAdapter() {
		if (historyStateItemProvider == null) {
			historyStateItemProvider = new HistoryStateItemProvider(this);
		}

		return historyStateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.NextNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NextNodeItemProvider nextNodeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.NextNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createNextNodeAdapter() {
		if (nextNodeItemProvider == null) {
			nextNodeItemProvider = new NextNodeItemProvider(this);
		}

		return nextNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.StopNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StopNodeItemProvider stopNodeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.StopNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createStopNodeAdapter() {
		if (stopNodeItemProvider == null) {
			stopNodeItemProvider = new StopNodeItemProvider(this);
		}

		return stopNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ReturnNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReturnNodeItemProvider returnNodeItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ReturnNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createReturnNodeAdapter() {
		if (returnNodeItemProvider == null) {
			returnNodeItemProvider = new ReturnNodeItemProvider(this);
		}

		return returnNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Assignment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AssignmentItemProvider assignmentItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Assignment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAssignmentAdapter() {
		if (assignmentItemProvider == null) {
			assignmentItemProvider = new AssignmentItemProvider(this);
		}

		return assignmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Play} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PlayItemProvider playItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Play}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createPlayAdapter() {
		if (playItemProvider == null) {
			playItemProvider = new PlayItemProvider(this);
		}

		return playItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Uninterpreted} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UninterpretedItemProvider uninterpretedItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Uninterpreted}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createUninterpretedAdapter() {
		if (uninterpretedItemProvider == null) {
			uninterpretedItemProvider = new UninterpretedItemProvider(this);
		}

		return uninterpretedItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.IfThenElse} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IfThenElseItemProvider ifThenElseItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.IfThenElse}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createIfThenElseAdapter() {
		if (ifThenElseItemProvider == null) {
			ifThenElseItemProvider = new IfThenElseItemProvider(this);
		}

		return ifThenElseItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.While} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WhileItemProvider whileItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.While}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createWhileAdapter() {
		if (whileItemProvider == null) {
			whileItemProvider = new WhileItemProvider(this);
		}

		return whileItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ReturnAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReturnActionItemProvider returnActionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ReturnAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createReturnActionAdapter() {
		if (returnActionItemProvider == null) {
			returnActionItemProvider = new ReturnActionItemProvider(this);
		}

		return returnActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.CallAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallActionItemProvider callActionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.CallAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCallActionAdapter() {
		if (callActionItemProvider == null) {
			callActionItemProvider = new CallActionItemProvider(this);
		}

		return callActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.DTMF} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DTMFItemProvider dtmfItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.DTMF}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDTMFAdapter() {
		if (dtmfItemProvider == null) {
			dtmfItemProvider = new DTMFItemProvider(this);
		}

		return dtmfItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Reject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RejectItemProvider rejectItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Reject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRejectAdapter() {
		if (rejectItemProvider == null) {
			rejectItemProvider = new RejectItemProvider(this);
		}

		return rejectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Inactivity} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InactivityItemProvider inactivityItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Inactivity}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createInactivityAdapter() {
		if (inactivityItemProvider == null) {
			inactivityItemProvider = new InactivityItemProvider(this);
		}

		return inactivityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Concept} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConceptItemProvider conceptItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Concept}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConceptAdapter() {
		if (conceptItemProvider == null) {
			conceptItemProvider = new ConceptItemProvider(this);
		}

		return conceptItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ExternalEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalEventItemProvider externalEventItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ExternalEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createExternalEventAdapter() {
		if (externalEventItemProvider == null) {
			externalEventItemProvider = new ExternalEventItemProvider(this);
		}

		return externalEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.AnyDtmf} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AnyDtmfItemProvider anyDtmfItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.AnyDtmf}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAnyDtmfAdapter() {
		if (anyDtmfItemProvider == null) {
			anyDtmfItemProvider = new AnyDtmfItemProvider(this);
		}

		return anyDtmfItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.AnyDigit} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AnyDigitItemProvider anyDigitItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.AnyDigit}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAnyDigitAdapter() {
		if (anyDigitItemProvider == null) {
			anyDigitItemProvider = new AnyDigitItemProvider(this);
		}

		return anyDigitItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Recording} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RecordingItemProvider recordingItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Recording}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRecordingAdapter() {
		if (recordingItemProvider == null) {
			recordingItemProvider = new RecordingItemProvider(this);
		}

		return recordingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.AbstractDTMF} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractDTMFItemProvider abstractDTMFItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.AbstractDTMF}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAbstractDTMFAdapter() {
		if (abstractDTMFItemProvider == null) {
			abstractDTMFItemProvider = new AbstractDTMFItemProvider(this);
		}

		return abstractDTMFItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.MessageEnd} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MessageEndItemProvider messageEndItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.MessageEnd}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createMessageEndAdapter() {
		if (messageEndItemProvider == null) {
			messageEndItemProvider = new MessageEndItemProvider(this);
		}

		return messageEndItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.SystemInput} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SystemInputItemProvider systemInputItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.SystemInput}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createSystemInputAdapter() {
		if (systemInputItemProvider == null) {
			systemInputItemProvider = new SystemInputItemProvider(this);
		}

		return systemInputItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Message} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MessageItemProvider messageItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Message}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createMessageAdapter() {
		if (messageItemProvider == null) {
			messageItemProvider = new MessageItemProvider(this);
		}

		return messageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.FixPart} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FixPartItemProvider fixPartItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.FixPart}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createFixPartAdapter() {
		if (fixPartItemProvider == null) {
			fixPartItemProvider = new FixPartItemProvider(this);
		}

		return fixPartItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.VariablePart} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VariablePartItemProvider variablePartItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.VariablePart}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createVariablePartAdapter() {
		if (variablePartItemProvider == null) {
			variablePartItemProvider = new VariablePartItemProvider(this);
		}

		return variablePartItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ConditionalElement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionalElementItemProvider conditionalElementItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ConditionalElement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConditionalElementAdapter() {
		if (conditionalElementItemProvider == null) {
			conditionalElementItemProvider = new ConditionalElementItemProvider(this);
		}

		return conditionalElementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.SilencePart} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SilencePartItemProvider silencePartItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.SilencePart}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createSilencePartAdapter() {
		if (silencePartItemProvider == null) {
			silencePartItemProvider = new SilencePartItemProvider(this);
		}

		return silencePartItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.UseElement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UseElementItemProvider useElementItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.UseElement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createUseElementAdapter() {
		if (useElementItemProvider == null) {
			useElementItemProvider = new UseElementItemProvider(this);
		}

		return useElementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.MessageElementCondition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MessageElementConditionItemProvider messageElementConditionItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.MessageElementCondition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createMessageElementConditionAdapter() {
		if (messageElementConditionItemProvider == null) {
			messageElementConditionItemProvider = new MessageElementConditionItemProvider(this);
		}

		return messageElementConditionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.ForEachElement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ForEachElementItemProvider forEachElementItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.ForEachElement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createForEachElementAdapter() {
		if (forEachElementItemProvider == null) {
			forEachElementItemProvider = new ForEachElementItemProvider(this);
		}

		return forEachElementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Grammar} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GrammarItemProvider grammarItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Grammar}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createGrammarAdapter() {
		if (grammarItemProvider == null) {
			grammarItemProvider = new GrammarItemProvider(this);
		}

		return grammarItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.VoiceService} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VoiceServiceItemProvider voiceServiceItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.VoiceService}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createVoiceServiceAdapter() {
		if (voiceServiceItemProvider == null) {
			voiceServiceItemProvider = new VoiceServiceItemProvider(this);
		}

		return voiceServiceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Service} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServiceItemProvider serviceItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Service}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createServiceAdapter() {
		if (serviceItemProvider == null) {
			serviceItemProvider = new ServiceItemProvider(this);
		}

		return serviceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Functionality} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FunctionalityItemProvider functionalityItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Functionality}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createFunctionalityAdapter() {
		if (functionalityItemProvider == null) {
			functionalityItemProvider = new FunctionalityItemProvider(this);
		}

		return functionalityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Actor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActorItemProvider actorItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Actor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createActorAdapter() {
		if (actorItemProvider == null) {
			actorItemProvider = new ActorItemProvider(this);
		}

		return actorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Entity} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EntityItemProvider entityItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Entity}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createEntityAdapter() {
		if (entityItemProvider == null) {
			entityItemProvider = new EntityItemProvider(this);
		}

		return entityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.orange_ftgroup.voice.Environment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnvironmentItemProvider environmentItemProvider;

	/**
	 * This creates an adapter for a {@link com.orange_ftgroup.voice.Environment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createEnvironmentAdapter() {
		if (environmentItemProvider == null) {
			environmentItemProvider = new EnvironmentItemProvider(this);
		}

		return environmentItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (parameterItemProvider != null) parameterItemProvider.dispose();
		if (operationItemProvider != null) operationItemProvider.dispose();
		if (constraintItemProvider != null) constraintItemProvider.dispose();
		if (packageItemProvider != null) packageItemProvider.dispose();
		if (dataTypeItemProvider != null) dataTypeItemProvider.dispose();
		if (tagItemProvider != null) tagItemProvider.dispose();
		if (propertyItemProvider != null) propertyItemProvider.dispose();
		if (classItemProvider != null) classItemProvider.dispose();
		if (binaryExpressionItemProvider != null) binaryExpressionItemProvider.dispose();
		if (unaryExpressionItemProvider != null) unaryExpressionItemProvider.dispose();
		if (characterValueItemProvider != null) characterValueItemProvider.dispose();
		if (integerValueItemProvider != null) integerValueItemProvider.dispose();
		if (floatValueItemProvider != null) floatValueItemProvider.dispose();
		if (booleanValueItemProvider != null) booleanValueItemProvider.dispose();
		if (charstringValueItemProvider != null) charstringValueItemProvider.dispose();
		if (identItemProvider != null) identItemProvider.dispose();
		if (parenthesisExpressionItemProvider != null) parenthesisExpressionItemProvider.dispose();
		if (conditionalExpressionItemProvider != null) conditionalExpressionItemProvider.dispose();
		if (listExpressionItemProvider != null) listExpressionItemProvider.dispose();
		if (callExpressionItemProvider != null) callExpressionItemProvider.dispose();
		if (enumerationTypeItemProvider != null) enumerationTypeItemProvider.dispose();
		if (enumerationItemItemProvider != null) enumerationItemItemProvider.dispose();
		if (choiceTypeItemProvider != null) choiceTypeItemProvider.dispose();
		if (listTypeItemProvider != null) listTypeItemProvider.dispose();
		if (variableItemProvider != null) variableItemProvider.dispose();
		if (informalExpressionItemProvider != null) informalExpressionItemProvider.dispose();
		if (actionSequenceItemProvider != null) actionSequenceItemProvider.dispose();
		if (digitValueItemProvider != null) digitValueItemProvider.dispose();
		if (dtmfValueItemProvider != null) dtmfValueItemProvider.dispose();
		if (featureExpressionItemProvider != null) featureExpressionItemProvider.dispose();
		if (propertyExpressionItemProvider != null) propertyExpressionItemProvider.dispose();
		if (collectionRangeItemProvider != null) collectionRangeItemProvider.dispose();
		if (collectionLiteralExpressionItemProvider != null) collectionLiteralExpressionItemProvider.dispose();
		if (collectionItemItemProvider != null) collectionItemItemProvider.dispose();
		if (enumValueItemProvider != null) enumValueItemProvider.dispose();
		if (stateMachineItemProvider != null) stateMachineItemProvider.dispose();
		if (newExpressionItemProvider != null) newExpressionItemProvider.dispose();
		if (valueContainerItemProvider != null) valueContainerItemProvider.dispose();
		if (dialogItemProvider != null) dialogItemProvider.dispose();
		if (subDialogStateItemProvider != null) subDialogStateItemProvider.dispose();
		if (transitionItemProvider != null) transitionItemProvider.dispose();
		if (triggerItemProvider != null) triggerItemProvider.dispose();
		if (waitStateItemProvider != null) waitStateItemProvider.dispose();
		if (anyStateItemProvider != null) anyStateItemProvider.dispose();
		if (listStateItemProvider != null) listStateItemProvider.dispose();
		if (decisionNodeItemProvider != null) decisionNodeItemProvider.dispose();
		if (initialNodeItemProvider != null) initialNodeItemProvider.dispose();
		if (junctionNodeItemProvider != null) junctionNodeItemProvider.dispose();
		if (diversionNodeItemProvider != null) diversionNodeItemProvider.dispose();
		if (historyStateItemProvider != null) historyStateItemProvider.dispose();
		if (nextNodeItemProvider != null) nextNodeItemProvider.dispose();
		if (stopNodeItemProvider != null) stopNodeItemProvider.dispose();
		if (returnNodeItemProvider != null) returnNodeItemProvider.dispose();
		if (assignmentItemProvider != null) assignmentItemProvider.dispose();
		if (playItemProvider != null) playItemProvider.dispose();
		if (uninterpretedItemProvider != null) uninterpretedItemProvider.dispose();
		if (ifThenElseItemProvider != null) ifThenElseItemProvider.dispose();
		if (whileItemProvider != null) whileItemProvider.dispose();
		if (returnActionItemProvider != null) returnActionItemProvider.dispose();
		if (callActionItemProvider != null) callActionItemProvider.dispose();
		if (dtmfItemProvider != null) dtmfItemProvider.dispose();
		if (rejectItemProvider != null) rejectItemProvider.dispose();
		if (inactivityItemProvider != null) inactivityItemProvider.dispose();
		if (conceptItemProvider != null) conceptItemProvider.dispose();
		if (externalEventItemProvider != null) externalEventItemProvider.dispose();
		if (anyDtmfItemProvider != null) anyDtmfItemProvider.dispose();
		if (anyDigitItemProvider != null) anyDigitItemProvider.dispose();
		if (recordingItemProvider != null) recordingItemProvider.dispose();
		if (abstractDTMFItemProvider != null) abstractDTMFItemProvider.dispose();
		if (messageEndItemProvider != null) messageEndItemProvider.dispose();
		if (systemInputItemProvider != null) systemInputItemProvider.dispose();
		if (messageItemProvider != null) messageItemProvider.dispose();
		if (fixPartItemProvider != null) fixPartItemProvider.dispose();
		if (variablePartItemProvider != null) variablePartItemProvider.dispose();
		if (conditionalElementItemProvider != null) conditionalElementItemProvider.dispose();
		if (silencePartItemProvider != null) silencePartItemProvider.dispose();
		if (useElementItemProvider != null) useElementItemProvider.dispose();
		if (messageElementConditionItemProvider != null) messageElementConditionItemProvider.dispose();
		if (forEachElementItemProvider != null) forEachElementItemProvider.dispose();
		if (grammarItemProvider != null) grammarItemProvider.dispose();
		if (voiceServiceItemProvider != null) voiceServiceItemProvider.dispose();
		if (serviceItemProvider != null) serviceItemProvider.dispose();
		if (functionalityItemProvider != null) functionalityItemProvider.dispose();
		if (actorItemProvider != null) actorItemProvider.dispose();
		if (entityItemProvider != null) entityItemProvider.dispose();
		if (environmentItemProvider != null) environmentItemProvider.dispose();
	}

}
